#define WIN32_LEAN_AND_MEAN
#include "fstream.h"
#include "windows.h"

//Loads in a Windows .bmp file.  Will not read in OS/2 bmps (like those done in MSPaint)
//LoadDDB(Filename, Handle to a device context to be dependant to, Pointer to a palette to put in palette info, SIZE sturcture pointer to place .bmp size info
HBITMAP LoadDDB(char *name,HDC context,HPALETTE *hPal,SIZE *size)
{
    BITMAPFILEHEADER headr;
    BITMAPINFOHEADER infoh;


     const maxread = 45*1024;
     unsigned int numcolors=0;
    ifstream *ifs=new ifstream(name,ios::in|ios::binary);
    if(*ifs)
    {
     ifs->read((char*)&headr,sizeof(BITMAPFILEHEADER));
     if((LOBYTE(headr.bfType)!='B')||(HIBYTE(headr.bfType!='M')))return NULL;
     ifs->read((char*)&infoh,sizeof(BITMAPINFOHEADER));
     infoh.biWidth=infoh.biWidth;
     infoh.biClrImportant=0;
    if(infoh.biClrUsed!=0){numcolors=infoh.biClrUsed;}
    else
    {
    switch(infoh.biBitCount){
    case 1: {numcolors=2;}
    case 4: {numcolors=16;}
    case 8: {numcolors=256;}
    default: {numcolors=0;}
    }


    }
     LPBITMAPINFO info1;
     info1 = (LPBITMAPINFO) new BYTE[sizeof(BITMAPINFOHEADER)+(numcolors * sizeof(RGBQUAD))];
     ifs->seekg(sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER));
     ifs->read((char*)info1->bmiColors,numcolors*sizeof(RGBQUAD));
     info1->bmiHeader=infoh;
     unsigned long bmpsize=headr.bfSize;
     bmpsize=bmpsize-sizeof(BITMAPFILEHEADER);
     void far *data=new BYTE[bmpsize];
     LOGPALETTE far *logpal;
     logpal = (LPLOGPALETTE) new BYTE[(numcolors*sizeof(RGBQUAD))+sizeof(LOGPALETTE)];
     logpal->palVersion=0x0300;
     logpal->palNumEntries=numcolors;
     for(int n=0;n<numcolors;n++)
     {
       info1->bmiColors[n].rgbReserved=0;
     }

     for(unsigned int n=0;n<numcolors;n++)
       {
         logpal->palPalEntry[n].peRed=info1->bmiColors[n].rgbRed;
         logpal->palPalEntry[n].peBlue=info1->bmiColors[n].rgbBlue;
         logpal->palPalEntry[n].peGreen=info1->bmiColors[n].rgbGreen;
         logpal->palPalEntry[n].peFlags=PC_NOCOLLAPSE;
       }
    *hPal = CreatePalette(logpal);

    ifs->seekg(headr.bfOffBits,ios::beg);
    unsigned int chunk;
    unsigned int prevbmpsize=bmpsize;
    while(bmpsize>0)
    {
            if(bmpsize>=maxread)chunk=maxread;
            else chunk=bmpsize;
            ifs->read((char*)data, chunk);
            bmpsize-=chunk;
            (char*)data+=chunk;
    }
    (char*)data-=prevbmpsize;


     ifs->close();
     HBITMAP mybmp;
     size->cx=infoh.biWidth;
     size->cy=infoh.biHeight;
     mybmp=CreateDIBitmap(context,&infoh,CBM_INIT,data,info1,DIB_RGB_COLORS);
      delete info1;
      delete data;
      delete ifs;
      delete logpal;
     return mybmp;
    }
delete ifs;
return NULL;
}

